/***************************************
 MMC3 Mapper199 V5
***************************************/
function cpu_dump(d, prg_size, banksize)
{
	cpu_write(d, 0xa001, 0); //disable W-RAM
	for(local i = 0; i < (prg_size/0x2000) - 2; i += 1){
		cpu_write(d, 0x8000, 6);
		cpu_write(d, 0x8001, i);
		//cpu_write(d, 0x8000, 7);
		//cpu_write(d, 0x8001, i | 1);
		cpu_read(d, 0x8000, 0x2000);
	}
	cpu_read(d, 0xc000, 0x2000 * 2);
}
function ppu_dump(d, chr_size, banksize)
{
	for(local i = 0; i < chr_size/0x400; i+=4){
		cpu_write(d, 0x8000,2,0x8001, i,  0x8000, 3,0x8001, i | 1);
		cpu_write(d, 0x8000,4,0x8001, i|2,0x8000, 5,0x8001, i | 3);
		ppu_read(d, 0x1000, 0x400 * 4);
	}
}

function cpu_erase(d, prg_size, prg_size_dummy)
{
	cpu_write(d, 0xa001, 0); //disable W-RAM
	cpu_write_flash(d,0x8555,0xF0);
	cpu_write_flash(d,0x8555,0xAA);
	cpu_write_flash(d,0x82AA,0x55);
	cpu_write_flash(d,0x8555,0x80);
	cpu_write_flash(d,0x8555,0xAA);
	cpu_write_flash(d,0x82AA,0x55);
	cpu_write_flash(d,0x8555,0x10);
}
function cpu_flash(d, prg_size, prg_size_dummy)
{
	flash_configure(d,0xA000,0xA555,0xA2AA,0xA555);
	cpu_write(d,0x8000,6,0x8001,0);
	cpu_write(d,0x8000,8,0x8001,0x3e);

	for(local i = 0; i < (prg_size/0x2000)-2; i += 1){
		cpu_write(d, 0x8000, 7);
		cpu_write(d, 0x8001, i);
		prg_flash(d, 0xa000, 0x2000);
	}
	prg_flash(d, 0xc000, 0x2000 * 2)
}

function ppu_erase(d, chr_size, chr_size_dummy)
{
	cpu_write(d, 0xa001, 0); //disable W-RAM
	
	//ppu_command(d, 0x0000, 0x1000, ppu_banksize);
	//ppu_command(d, 0x2aaa, 0x0000, 0x0800);//2AA
	//ppu_command(d, 0x5555, 0x0800, 0x0800);//555
	cpu_write(d, 0x8000, 0);//0-800
	cpu_write(d, 0x8001, 0x0a*2);
	cpu_write(d, 0x8000, 10);//0-800
	cpu_write(d, 0x8001, 0x0a*2+1);
	cpu_write(d, 0x8000, 1);//800-1000
	cpu_write(d, 0x8001, 0x14*2);
	cpu_write(d, 0x8000, 11);//800-1000
	cpu_write(d, 0x8001, 0x14*2+1);
	
	ppu_write(d,0x555,0xF0);
	ppu_write(d,0x555,0xAA);
	ppu_write(d,0x2AA,0x55);
	ppu_write(d,0x555,0x80);
	ppu_write(d,0x555,0xAA);
	ppu_write(d,0x2AA,0x55);
	ppu_write(d,0x555,0x10);
}
function ppu_flash(d, chr_size, chr_size_dummy)
{
	flash_configure(d,0x1555,0x1555,0x12AA,0x1555);

	for(local i = 0; i < (chr_size/0x400); i += 4){
		cpu_write(d, 0x8000, 2);
		cpu_write(d, 0x8001, i|0);
		cpu_write(d, 0x8000, 3);
		cpu_write(d, 0x8001, i|1);
		cpu_write(d, 0x8000, 4);
		cpu_write(d, 0x8001, i|2);
		cpu_write(d, 0x8000, 5);
		cpu_write(d, 0x8001, i|3);
		chr_flash(d, 0x1000, 0x1000);
	}
}

