/***************************************
 Mapper36
***************************************/
function cpu_dump(d, prg_size, banksize)
{
	for(local i = 0; i < (prg_size/0x8000); i += 1){
		cpu_write(d, 0x8001, i<<4);
		cpu_read(d, 0x8000, 0x8000);
	}
}
function ppu_dump(d, chr_size, banksize)
{
	for(local i = 0; i < chr_size/0x2000; i+=1){
		cpu_write(d, 0x8000,i);
		ppu_read(d, 0x0000, 0x2000);
	}
}

function cpu_erase(d, prg_size, prg_size_dummy)
{
	cpu_write_flash(d,0x8555,0xF0);
	cpu_write_flash(d,0x8555,0xAA);
	cpu_write_flash(d,0x82AA,0x55);
	cpu_write_flash(d,0x8555,0x80);
	cpu_write_flash(d,0x8555,0xAA);
	cpu_write_flash(d,0x82AA,0x55);
	cpu_write_flash(d,0x8555,0x10);
}
function cpu_flash(d, prg_size, prg_size_dummy)
{
	flash_configure(d,0x8000,0x8555,0x82AA,0x8555);
	for(local i = 0; i < (prg_size/0x8000); i += 1){
		cpu_write(d, 0x8001, i<<4);
		prg_flash(d, 0x8000, 0x8000);
	}
}

function ppu_erase(d, chr_size, chr_size_dummy)
{
	ppu_write(d,0x555,0xF0);
	ppu_write(d,0x555,0xAA);
	ppu_write(d,0x2AA,0x55);
	ppu_write(d,0x555,0x80);
	ppu_write(d,0x555,0xAA);
	ppu_write(d,0x2AA,0x55);
	ppu_write(d,0x555,0x10);
}
function ppu_flash(d, chr_size, chr_size_dummy)
{
	flash_configure(d,0x555,0x555,0x2AA,0x555);

	for(local i = 0; i < chr_size/0x2000; i+=1){
		cpu_write(d, 0x8001, i);
		chr_flash(d, 0x0000, 0x2000);
	}
}

